package com.axiante.samples.stream.utils;

import java.sql.ResultSet;
import java.util.stream.IntStream;

/**
 * Provider for testing purposes.
 * 
 * @author marco
 *
 */
public class TableProvider {

    private static Boolean initialized = false;
    public static final int rows = 10;
    static {
	synchronized (initialized) {
	    if (!initialized) {
		DerbyManager.start();
		IntStream.rangeClosed(1, rows).forEach(i -> {
		    DerbyManager.insertRestaurants(i, "restaurant" + i, "city" + i);
		});
		initialized = true;
	    }
	}
    }

    public ResultSet selectRestaurants() {
	return DerbyManager.selectRestaurants();
    }


}
