package com.axiante.samples.stream;

import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertThat;

import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.ResultSet;

import org.hamcrest.CoreMatchers;
import org.junit.Test;

import com.axiante.samples.stream.utils.TableProvider;

public class DbStreamTest {
    TableProvider provider = new TableProvider();
    
    private static final String CSV= "" + 
    	"\"ID\",\"NAME\",\"CITY\"\n" + 
    	"\"1\",\"restaurant1\",\"city1\"\n" + 
    	"\"2\",\"restaurant2\",\"city2\"\n" + 
    	"\"3\",\"restaurant3\",\"city3\"\n" + 
    	"\"4\",\"restaurant4\",\"city4\"\n" + 
    	"\"5\",\"restaurant5\",\"city5\"\n" + 
    	"\"6\",\"restaurant6\",\"city6\"\n" + 
    	"\"7\",\"restaurant7\",\"city7\"\n" + 
    	"\"8\",\"restaurant8\",\"city8\"\n" + 
    	"\"9\",\"restaurant9\",\"city9\"\n" + 
    	"\"10\",\"restaurant10\",\"city10\"\n";

    @Test
    public void testConstuctor() {
	ResultSet expected = provider.selectRestaurants();
	try (DbStream test = new DbStream(expected)) {
	    assertThat(test.getTable(), CoreMatchers.equalTo(expected));
	} catch (IOException e) {

	}
    }

    @Test
    public void testStream() {
	    StringBuilder builder = new StringBuilder();
	try (DbStream test = new DbStream(provider.selectRestaurants());) {
	    int count;
	    InputStreamReader reader = new InputStreamReader(test);
	    char[] buf = new char[1000];
	    while((count = reader.read(buf)) != -1) {
		builder.append(buf,0,count);
	    }
	} catch (IOException e) {

	}
	
	assertNotNull(builder);
//	String csv = builder.toString().replace("######", "\n");
	//"######
	String csv = builder.toString();
	assertThat(csv, CoreMatchers.containsString("restaurant"));
	assertThat(csv, CoreMatchers.containsString("city"));
	assertThat (csv, CoreMatchers.equalTo(CSV));
	
    }
    
}
