package com.axiante.samples.stream.utils;

import static org.hamcrest.Matchers.greaterThan;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertThat;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

public class DerbyManagerTest {

    @BeforeClass
    public static void init() {
	DerbyManager.start();
    }

    @Test
    public void testDbCreation() {
	ResultSet test = DerbyManager.selectRestaurants();
	assertNotNull(test);
    }

    @Test
    public void testDataCreation() throws SQLException {
	int i = 0;
	DerbyManager.insertRestaurants(i, "restaurant" + i, "city" + i);
	ResultSet test = DerbyManager.selectRestaurants();
	if (test != null){
	    while(test.next()) {
		++i;
	    }
	}
	assertThat(i, greaterThan(0));
    }

    @AfterClass
    public static void close() {
	DerbyManager.stop();
    }

}
